from practicum import McuBoard

RQ_SET_LED    = 0
RQ_GET_SWITCH = 1
RQ_GET_LIGHT  = 2

####################################
class PeriBoard(McuBoard):

    b = McuBoard()
    ################################
    def setLed(self, led_no, led_val):
        '''
        Set status of LED led_no on peripheral board to led_val
        '''
        self.usb_write(0, index=led_no, value=led_val)
        pass

    ################################
    def setLedValue(self, value):
        '''
        Display value's 3 LSBs on peripheral board's LEDs
        '''
        self.usb_write(RQ_SET_LED, index=0, value= value % 2)
        value = value >> 1
        self.usb_write(RQ_SET_LED, index=1, value= value % 2)
        value = value >> 1
        self.usb_write(RQ_SET_LED, index=2, value= value % 2)
        pass

    ################################
    def getSwitch(self):
        '''
        Return a boolean value indicating whether the switch on the peripheral
        board is currently pressed
        '''
        a=self.usb_read(RQ_GET_SWITCH, length=1)
        if a[0] == 1:
            return True
        return False

    ################################
    def getLight(self):
        '''
        Return the current reading of light sensor on peripheral board
        '''
        light = self.usb_read(RQ_GET_LIGHT, length=2)
        return light[0]+light[1]*256
