import kivy
import random
kivy.require('1.1.1')

from kivy.app import App
from kivy.uix.widget import Widget
from kivy.properties import NumericProperty, ReferenceListProperty,\
    ObjectProperty
from kivy.vector import Vector
from kivy.clock import Clock
from peri import PeriBoard
from time import sleep


class PongPaddle(Widget):
    
    score = NumericProperty(0)
    clash = 0
    def bounce_ball(self, ball):
        if self.collide_widget(ball):
            vx, vy = ball.velocity
            offset = (ball.center_y - self.center_y) / (self.height / 2)
            bounced = Vector( vx*-9999999999,vy)
	    clash = 1
            vel = bounced * 1.0
            ball.velocity = vel.x, vel.y + offset


class PongBall(Widget):
    
    velocity_x = NumericProperty(0)
    velocity_y = NumericProperty(0)
    velocity = ReferenceListProperty(velocity_x, velocity_y)
    #velocity of paddle
    def move(self,dif):
        self.pos = Vector(*self.velocity)*dif + self.pos
	
	


class PongGame(Widget):
    ball = ObjectProperty(None)
    player1 = ObjectProperty(None)
    player2 = ObjectProperty(None)
    peri = PeriBoard()
    #p=0
    sTing = 0
    

    factor1=0.45555
    factor2=1-factor1
    def serve_ball(self, vel=(4, 0)):
        self.ball.x = self.width-(2*self.ball.width)
        self.ball.y = self.player2.y
        self.ball.velocity = vel
  
    def update(self, dt):
        vecTing = 0.1*((self.peri.getLight()-110.0)/500 * self.height - self.player1.center_y)
        self.ball.move(self.player2.score/10*0.1+1)
        #self.player1.center_y = self.factor1*self.peri.getLight()+self.factor2*self.p
        self.sTing += vecTing
        self.player1.center_y = self.factor1* self.sTing + self.factor2*self.sTing
        

        
	print self.ball.pos
        print self.player1.center_y
        #bounce of paddles
        self.player1.bounce_ball(self.ball)
        #self.player2.bounce_ball(self.ball)
	self.player2.height = 350

        #bounce ball off bottom or top
     #   if (self.ball.y < self.y) or (self.ball.top > self.top):
      #      self.ball.velocity_y *= -1

        #went of to a side to score point?
        if self.ball.x < self.x:
            self.player2.score += 1
	    
	#highscore
	    if self.player2.score >= self.player1.score:
	        self.player1.score = self.player2.score
		
            self.serve_ball(vel=(-10, 0))
	    
	    
	self.ball.pos *= 10      
        if self.ball.x > self.width- 20:
            self.player2.score = 0
	#first serve
            self.serve_ball(vel=(-10, 0))
	    
        self.player2.center_y = random.random()*self.height


class PongApp(App):
    def build(self):
        game = PongGame()
        game.serve_ball()
        Clock.schedule_interval(game.update, 1.0 / 60.0)
        return game


if __name__ == '__main__':
    PongApp().run()
