from practicum import McuBoard

RQ_SET_LED    = 0
RQ_GET_SWITCH = 1
RQ_GET_LIGHT  = 2

####################################
class PeriBoard(McuBoard):

    ################################
    def setLed(self, led_no, led_val):
        self.usb_write(RQ_SET_LED, index=led_no, value=led_val)

        '''
        Set status of LED led_no on peripheral board to led_val
        '''
        pass

    ################################
    def setLedValue(self, value):
	self.setLed(2,(value & 0b001))
        self.setLed(1,(value & 0b010)>>1)
        self.setLed(0,(value & 0b100)>>2)

        '''
        Display value's 3 LSBs on peripheral board's LEDs
        '''
        pass

    ################################
    def getSwitch(self):
        state = self.usb_read(RQ_GET_SWITCH, length=1)
        if state[0] is 1:
            return True
        else:
            return False
       
            
            
        
        '''
        Return a boolean value indicating whether the switch on the peripheral
        board is currently pressed
        '''
        pass

    ################################
    def getLight(self):
        light = self.usb_read(RQ_GET_LIGHT, length=2)
        result=light[0]+light[1]*256
        return result
        '''
        Return the current reading of light sensor on peripheral board
        '''
        pass
